<?php

require_once('request.php');
require_once('../arav_up_inclu/base64codec.php');
require_once('../arav_up_inclu/utils.php');

class arkiwiRequestPostUpload extends arkiwiRequest {
    private $sId = null;
    private $path = null;

    public function __construct($request) {
        parent::__construct($request);

        $extra = $this->getRequestExtra();

        $this->path = "/".decoder($extra[0]);
    }

    public function run() {
        report(REPPRIO::DEBUG, "Entering arkiwiRequestPostUpload");

        if($this->request['method'] != 'POST') {
            report(REPPRIO::FATAL, "arkiwiRequestPostUpload: POST method required.");
            $this->setBodyError(500, "arkiwiRequestPostUpload: POST method required.");
            return;
        }

//        if ($this->path != $_SESSION['authstate']['dir']) {
//            report(REPPRIO::FATAL, "No permission to write in requested dir :".$this->path);
//            $this->setBodyError(401, "No permission to write in requested dir :".$this->path);
//            return;
//        }

        if (!startsWith($this->path,$_SESSION['authstate']['dir'])) {
            report(REPPRIO::FATAL, "No permission to write in requested dir :".$this->path);
            $this->setBodyError(401, "No permission to write in requested dir :".$this->path);
            return;
        }

        $ok = false;

        $file = $_FILES['arkiwiuploadedfile'];

        if ($file !== FALSE && !empty($file) && $file['error'] == UPLOAD_ERR_OK) {
            $ok = $this->upload($file, $this->path.'/'.$file['name']);
        }

        if ($ok == false) {
            report(REPPRIO::ERROR, "Your file has not been upload. Sorry :(");
            $this->setBodyError(400, "Your file has not been upload. Sorry :(");
        } else {
            report(REPPRIO::INFO, "Uploaded ".$GLOBALS["conf"]["data_basedir"]." ".$this->path.'/'.$file['name']);

            //calcola il path in base64
            $item64 = encoder(substr($this->path, 1).'/'.$file['name']);

            $this->setCode(201);
            $this->setBodyJSON(Array('success' => true, 'item64' => $item64));
        }
    }

    private function upload($obj, $destinationFolder) {
        if (!$obj) {
            return false;
        }
        report(REPPRIO::DEBUG, "Uploading ".$GLOBALS["conf"]["data_basedir"]." ".$destinationFolder);
        $realDestination = $GLOBALS["conf"]["data_basedir"].$destinationFolder;
        $uploadResult =  move_uploaded_file($obj['tmp_name'], $realDestination);

        return $uploadResult;
    }
}
